/**
 * Created by robin on 10/24/15.
 */

angular.module('luticate', []);
(function () {
    'use strict';
    angular.module('luticate')
        .factory('luticateUtils', ['$q', '$http', function ($q, $http) {

            var coPlanningServices = {};

            coPlanningServices.get = function(url, dataGet)
            {
                return coPlanningServices.request(url, 'GET', dataGet, null);
            };

            coPlanningServices.post = function(url, dataPost, dataGet)
            {
                return coPlanningServices.request(url, 'POST', dataGet, dataPost);
            };

            coPlanningServices.put = function(url, dataPost, dataGet)
            {
                return coPlanningServices.request(url, 'PUT', dataGet, dataPost);
            };

            coPlanningServices.delete = function(url, dataPost, dataGet)
            {
                return coPlanningServices.request(url, 'DELETE', dataGet, dataPost);
            };

            coPlanningServices.request = function(url, method, dataGet, dataPost)
            {
                var defered = $q.defer();

                var params = {
                    url: url,
                    method: method,
                    params: dataGet,
                    data: dataPost
                };

                $http(params)
                    .success(function (result, status) {
                        if (result.Message != null) {
                            defered.reject({
                                data: result.Message,
                                status: status
                            });
                        }
                        else {
                            defered.resolve(result.Data);
                        }
                    })
                    .error(function (result, status) {
                        if (result.Message != null) {
                            defered.reject({
                                data: result.Message,
                                status: status
                            });
                        }
                        else {
                            defered.reject({
                                data: result,
                                status: status
                            });
                        }
                    });
                return defered.promise;
            };

            return coPlanningServices;
        }]);
})();